/* $Revision: 7.3 $ */
/* $Author: christos $ */
/* $Id: vector.h,v 7.3 1995/03/17 00:20:17 christos Exp christos $ */



#define TRUE 1
#define FALSE 0

#ifndef __FastMap_h
  #define __FastMap_h
  #include <malloc.h>
  #include <assert.h>
  #include <stdio.h>
  #include <string.h>
  #include <strings.h>
  #include <math.h>
  #include <stdlib.h>

   /*===================================================*/
   #ifndef __NUMBER
      typedef double NUMBER;
   #endif
   #ifndef __BOOLEAN
      typedef int BOOLEAN;
      #define TRUE 1
      #define FALSE 0
   #endif
   /*===================================================*/


  
  /*===================================================*/
  /* 1-d vector, with size */
  typedef struct Vector { 
     int len;
     NUMBER *vec;
  } VECTOR;
  
  VECTOR *vecalloc(int n);
  void vecfree( VECTOR *);  
  NUMBER vecdist2( VECTOR *, VECTOR *); /* squared Eucl. distance */  
  void vecput( VECTOR *pvec, int pos, NUMBER val); 
  NUMBER vecget( VECTOR *pvec, int pos );
  VECTOR *veccopy( VECTOR *p); 
  void vecprint( VECTOR *p);
  /*===================================================*/



   /*===================================================*/
   /* 1-d vector, with size */
    typedef struct Object { 
       int len;
       NUMBER *vec;
    } OBJECT;
    
  OBJECT *oballoc(int n);
  void obfree( OBJECT *);
  NUMBER obdist2( OBJECT *, OBJECT *); /* squared Eucl. distance */
  void obput( OBJECT *pob, int pos, NUMBER val);
  NUMBER obget( OBJECT *pob, int pos );
  OBJECT *obcopy( OBJECT *p);
  void obprint( OBJECT *p);
  OBJECT *line2ob(char *line);
  /*===================================================*/



    /*===================================================*/
    /* matrix */
    typedef struct Matrix {
       int count;
       VECTOR **list;
    } MATRIX;
    
    MATRIX *matrixalloc(int n); 
    void matrixfree( MATRIX *);   
    void matrixput( MATRIX *pmat, int pos, VECTOR *pvec);
    void matrix2put( MATRIX *pmatrix, int row, int column, NUMBER val);    
    VECTOR *matrixget( MATRIX *pmat, int pos );
    NUMBER matrix2get( MATRIX *pmatrix, int row, int column);    
    void matrixprint(MATRIX *pmatrix);
    void printvdist2(MATRIX *pmatrix);
    /*===================================================*/



    /*===================================================*/
    /* object array */
    typedef struct Oa {
       int count;
       OBJECT **list;
    } OA;

    OA *oaalloc(int n);  
    void oafree( OA *);  
    void oaput( OA *poa, int pos, OBJECT *pob);
    void oaprint( OA *poa);   
    OBJECT *oaget( OA *poa, int pos );    
    MATRIX *fastmap( OA *poa, int k);
    void pickAnchors(OA *poa, int *pa1, int *pa2, int dims, MATRIX *pmat);
    int Furthest( OA *poa, int i, int dims, MATRIX *pmat);
    NUMBER mydist2( OA *poa, int o1, int o2, int dims, MATRIX *pmat);
    void printdist( OA *poa);
    void printdist2( OA *poa);
    OA *file2oa(FILE *);
    /*===================================================*/



    /*===================================================*/
    #define MAXLINE 10000
    #define BLANKS " \t\n"

    int countlines(FILE *fp);
    int countcolumns(FILE *fp);
    void checklength(char *line);
    int counttokens(char *line);
    char *getline(FILE *fp);
    BOOLEAN checkfile(FILE *fp);
    /* void checkfile(FILE *fp); */
    void myrewind(FILE *fp);
    /*===================================================*/



    /*===================================================*/
    OA *Mat2oa(float**,int,int);
    OBJECT *Mat2ob(float**,int,int);
    void convertmat(MATRIX*,float**);
    void fillMat(VECTOR*,float**,int);
    void MyFastMap(float**,float**,int,int,int,int);
    void MyFastMap_(float**,int,int,int,int); 
    /*===================================================*/
   
#endif
