//------------------------------------------------------
// module  : FunctionHyper.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions de reservations memoires utiles 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>

#include "FunctionHyper.h"


//-------------------------//
//-- Matrice de Flottant --//
//-------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de float
//----------------------------------------------------------
float**** fmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  float**** matrix;

  matrix=new float***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=fmatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------------//
//-- Matrice d'entiers short --//
//-----------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de short int
//----------------------------------------------------------
short int* simatrix_allocate_1d(int hsize)
 {
  short int* matrix;
  matrix=new short int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de short int
//----------------------------------------------------------
short int** simatrix_allocate_2d(int vsize,int hsize)
 {
  short int** matrix;
  short int*  imptr;

  matrix=new short int*[vsize];
  imptr=new  short int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de short int
//----------------------------------------------------------
short int*** simatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  short int*** matrix;

  matrix=new short int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=simatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de short int
//----------------------------------------------------------
short int**** simatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  short int**** matrix;

  matrix=new short int***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=simatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de float
//----------------------------------------------------------
void free_fmatrix_4d(float**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_fmatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }


//----------------------------------------------------------
// libere la memoire de la matrice 1d de short int
//----------------------------------------------------------
void free_simatrix_1d(short int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_simatrix_2d(short int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_simatrix_3d(short int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 4d de short int
//----------------------------------------------------------
void free_simatrix_4d(short int**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_simatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//--------------------//
//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float*** pmatl1,float*** pmatl2,int lgth,int wdth,int nbcoul)
{
 int i,j,k;

  for(k=0;k<nbcoul;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    pmatl1[k][i][j]=(int)(pmatl2[k][i][j]+0.49); 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 //Initialisation
 max=-1000000.0;
 min=100000000;

 //Recherche du min
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 //plus min
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 //Recherche du max
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 //Recalibre la matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void Recal(float*** mat,int lgth,int wdth)
{
 int i,j,k;
 float max,min;
 float tmp;

 //Boucle
 for(k=0;k<3;k++)
   {
    max=-10000;
    min=10000;

    //>min/max
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[k][i][j]<min) min=mat[k][i][j];
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[k][i][j]>max) max=mat[k][i][j];

    //>Debug
    printf("[min=%.1f max=%.1f]",min,max);
    fflush(stdout);
  
    //>Recalibre
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max) 
      { tmp=((float)mat[k][i][j]-(float)min)*(GREY_LEVEL/(float)(max-min));
        if (tmp<0)    tmp=0.0;
        if (tmp>255) tmp=255.0; 
        mat[k][i][j]=tmp; }  
   }     
}


//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void RecalI(float** mat,int lgth,int wdth,float min,float max)
{
 int i,j; 
 float scale;
 scale=max-min;

 //Recal [0-255]
 Recal(mat,lgth,wdth);
 
 //Recal [min-max]
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]*=scale/255.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]+=min; 
}


//----------------------------------------------------------
// ComputeMean
//----------------------------------------------------------
float ComputeMean(float** mat,int lgth,int wdth)
{
 int i,j;
 float Moy;

 Moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy+=mat[i][j]; 
 Moy/=(lgth*wdth);

 return Moy;
}

//----------------------------------------------------------
// ComputeDiff
//----------------------------------------------------------
float ComputeDiff(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;
 float Diff;

 Diff=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Diff+=fabs(mat1[i][j]-mat2[i][j]);
 Diff/=(lgth*wdth);

 return Diff;
}


//----------------------//
//----------------------//
//-- FILE -PGM/PPM------//
//----------------------//
//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,int*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;
  char Buff[600],stringTmp1[600],stringTmp2[600];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   strcpy(Buff,path);
   if (strstr(Buff,".ppm")==NULL) strcat(Buff,".ppm");

   //ouverture du fichier
  fic=fopen(Buff,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",Buff);
     exit(-1); }
   printf("\n Ouverture de -> %s au format ppm",Buff);
   fflush(stdout);
  
  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,600,fic); //Comment

  printf("\n >%s",stringTmp1);
  printf("\n >%s",stringTmp2); 
  fflush(stdout); 

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,600,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);

  //affichage de l'entete
  printf("\n\n -- Entete --");
  printf("\n ------------");
  printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  printf("\n ----------------------------------------------------------\n\n");
  fflush(stdout);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(const char* Path_out,char* Name,char* Com,float*** matrvb,int lgth,int wdth)
 {
   int i,j,k;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,Com);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n Sauvegarde dans -> %s au format %s",buff,"ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# %s \n",Com);
  fprintf(fuser,"%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { matrvb[k][i][j]=(int)(matrvb[k][i][j]+0.49);
      if (matrvb[k][i][j]<0)   matrvb[k][i][j]=0;
      if (matrvb[k][i][j]>255) matrvb[k][i][j]=255; }      

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { fprintf(fuser,"%c",(char)matrvb[0][i][j]);
      fprintf(fuser,"%c",(char)matrvb[1][i][j]);
      fprintf(fuser,"%c",(char)matrvb[2][i][j]); }
       
  //fermeture fichier
   fclose(fuser); 
 }

//------------------------------------------
//------------------------------------------
//---- LOAD HYPERSPECTRAL AVIRIS IMAGE -----
//------------------------------------------
//----------------------------------------------------------
// ByteSwap((unsigned char *) &x,sizeof(x))
// ByteSwap5(x)
//----------------------------------------------------------
void ByteSwap(unsigned char* b, int n)
{
 int i,j;
 int temp;

 //Init
 i = 0;
 j = n-1;

 while (i<j) { SWAP(b[i], b[j]); i++, j--; }
}

//----------------------------------------------------------
// Stat           
//----------------------------------------------------------     
void Stat(float** Img,int lgth,int wdth)
{
 int i,j;
 float min,max,moy; 

 //Stats
 min=10000000.0;
 max=-10000000.0;
 moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { moy+=Img[i][j];
      if(min>Img[i][j]) min=Img[i][j]; 
      if(max<Img[i][j]) max=Img[i][j];  }
  moy/=(lgth*wdth);
  printf("\n Stat::[min=%.1f | max=%.1f | Moy=%.1f]",min,max,moy);
  fflush(stdout);
}

//--------------------------------------------------------------
//
// .rfl     AVIRIS INVERTED REFLECTANCE IMAGE DATA
// 
// Contents:   AVIRIS inverted reflectance data (multipled by 10000)
// File type:  stored as BINARY 16-bit signed integer IEEE
// Units:      10000 times reflectance factor
//
// [dpth=224  width=614  length=512] > BINARY 16-bit signed integer
//
// column=width=samples = 614 
// lines=length=512
// bands=depth=224
// header offset = 0
// file type = ENVI Standard
// data type = 2 (octets)
// interleave = bip [depth,column,lines]
// sensor type = Unknown
// byte order = 1  (BigEndian, MSF, IEEE)
//
// Format::BIP:Band interleaved by pixel 
//                 [channel , sample  , line    ] 
// with dimensions [Band:224, wdth:614, lgth:512] 
//
//  BIP can be read with the following pseudo-code program
//
//  FOR EACH line (length)
//    FOR EACH pixel (width)
//        FOR EACH band (depth)
//            I[band, line, pixel] = get_pixel(input);
// 
//--------------------------------------------------------------
//----------------------------------------------------------
// LoadImageImg            
//----------------------------------------------------------     
void LoadImgHyperspectral(char* Path,short int*** DataImg,int dpth,int lgth,int wdth)
{
  int i,j,k;
  signed short int var; 
  float min,max,moy; 
  int flag;
  FILE *inputFile;

  //Verif LittleEndian/BigEndian
  int FlagByteorder=0; 
  int a=0x12345678;
  unsigned char *c=(unsigned char*)(&a);
  if (*c==0x78) { printf("LittleEndian LSBfirst (LSF) (x86 AMD=x86-64) Byteorder=0"); }
  else  { printf("BigEndian MSBfirst (MSF) Byteorder=1 IEEE");
          FlagByteorder=1; }
  fflush(stdout); 

  //>Open File
  printf("\n > Open File: %s... [",Path); fflush(stdout);
  inputFile=fopen(Path, "r");
  if(inputFile==NULL)
    { printf("\n-- Can't Open File, Error %s ---\n",Path);
      exit(-1); }

  //>Load File
  min=10000000.0;
  max=-10000000.0;
  for(i=0;i<lgth;i++) 
    {
     if (!(i%50)) { printf("-"); fflush(stdout); }
 
     for(j=0;j<wdth;j++) for(k=0;k<dpth;k++)   
	{ flag=fread(&var,2*sizeof(char),1,inputFile);
	  if (!FlagByteorder) ByteSwap5(var);

          if(min>var) min=var;
	  if(max<var) max=var;

          if (var>=0) DataImg[k][i][j]=var;
          else DataImg[k][i][j]=0; }
    }

  //>Close File
  fclose(inputFile);

  //>Resize File
  printf("] [min=%.1f | max=%.1f]",min,max);
  for(k=0;k<dpth;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  DataImg[k][i][j]=(int)((((float)DataImg[k][i][j])*255.0/(max))+0.49);

  //>Verifie Min/Max/Moy
  min=10000000.0;
  max=-10000000.0;
  moy=0.0;
  for(k=0;k<dpth;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { moy+=DataImg[k][i][j];
      if(min>DataImg[k][i][j]) min=DataImg[k][i][j]; 
      if(max<DataImg[k][i][j]) max=DataImg[k][i][j];  }
  moy/=(dpth*lgth*wdth);
  printf(" [min=%.0f | max=%.0f] <Moy=%.1f>",min,max,moy); 
}

//----------------------------------------------------------
// SelectInfoBands          
//----------------------------------------------------------     
void SelectInfoBands(short int*** DataImg,int dpth,int lgth,int wdth,int flgvisu,float** BandInfo,float RSB)
{
 int i,j,k;
 int cpt;
 float min,max,moy;
 float RSBopt;
 
 //Presentation
 printf("\n  >Info Bands [min,max,moy,RSBmin=%.0f] ",RSB);
 fflush(stdout);
 
 //Boucle
 cpt=0;
  for(k=0;k<dpth;k++)
   { min=10000000.0;
     max=-10000000.0;
     moy=0.0;
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  	{ moy+=DataImg[k][i][j];
          if(min>DataImg[k][i][j]) min=DataImg[k][i][j]; 
  	  if(max<DataImg[k][i][j]) max=DataImg[k][i][j]; }
      moy/=(lgth*wdth);

      //>Record
      BandInfo[k][0]=min;
      BandInfo[k][1]=max;
      BandInfo[k][2]=moy;
      BandInfo[k][3]=RSB_Estimation(DataImg[k],lgth,wdth);

      //>Visu
      if (flgvisu)
        { printf("\n [B%d :: min=%d max=%d moy=%.1f rsb=%.1f]",k,(int)min,(int)max,moy,BandInfo[k][3]); 
          fflush(stdout); } 
   }

 //Trouve RSB optimal
  RSBopt=RSB;
  for(;;)
    { for(cpt=0,k=0;k<dpth;k++) if (BandInfo[k][3]<RSBopt) cpt++;
      if (cpt<(dpth/3)) break;
      RSBopt/=1.5; 
      printf("\n >> RSBmin=%.1f\n",RSBopt); }

  //>Remove Band
  for(cpt=0,k=0;k<dpth;k++)
      if  (BandInfo[k][3]<RSBopt) 
	{ for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) DataImg[k][i][j]=0;
          cpt++;
          printf("\n [B%d :: min=%d max=%d",k,(int)BandInfo[k][0],(int)BandInfo[k][1]); 
          printf(" moy=%.1f rsb=%.1f] --erase",BandInfo[k][2],BandInfo[k][3]); }
  //Info
  printf("\n  >[%d] Bandes Supprimees",cpt);
 fflush(stdout);
}

//----------------------------------------------------------
// RSB_Estimation    
//----------------------------------------------------------     
float RSB_Estimation(short int** DataImg,int lgth,int wdth)
{
  int i,j,k;
  float tmp;
  float VarNoise;
  float MoyNoise;
  float VarImg;
  float MoyImg;
  float RSB;

 //Allocation memoire
 float** MatFiltered=fmatrix_allocate_2d(lgth,wdth);
 float** MatTmp=fmatrix_allocate_2d(lgth,wdth);

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatFiltered[i][j]=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatTmp[i][j]=DataImg[i][j];
 
 //Boucle
 for(k=0;k<3;k++)
   {
    for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++)
      { tmp=0.0;
        tmp+=4*MatTmp[i][j]+2*MatTmp[i-1][j]+2*MatTmp[i+1][j];
        tmp+=2*MatTmp[i][j-1]+2*MatTmp[i][j+1];
        tmp+=MatTmp[i+1][j+1]+MatTmp[i-1][j+1];
        tmp+=MatTmp[i+1][j-1]+MatTmp[i-1][j-1];
        tmp/=16.0;
        MatFiltered[i][j]=tmp; }
 
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatTmp[i][j]=MatFiltered[i][j];
   }

 //RSB
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatTmp[i][j]=0.0;
 for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++) MatTmp[i][j]=DataImg[i][j]-MatFiltered[i][j];

 MoyNoise=0.0;
 for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++) MoyNoise+=MatTmp[i][j];
 MoyNoise/=((lgth-1)*(wdth-1));
 VarNoise=0.0;
 for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++) VarNoise+=CARRE(MatTmp[i][j]-MoyNoise);
 VarNoise/=((lgth-1)*(wdth-1));

 MoyImg=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MoyImg+=MatFiltered[i][j];
 MoyImg/=(lgth*wdth);
 VarImg=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) VarImg+=CARRE(MatFiltered[i][j]-MoyImg);
 VarImg/=(lgth*wdth);

 RSB=VarImg/VarNoise;

 //Liberation
 if (MatFiltered) free_fmatrix_2d(MatFiltered);
 if (MatTmp)      free_fmatrix_2d(MatTmp);

 return RSB;
}

//--------------------------------
//--------------------------------
//----NONLOCALGRAPH---------------
//--------------------------------
//----------------------------------------------------------
// 
// ---------------
// ComputeNonLocalGraph <<Norme 2>> <<+4ppv>>
//
//---------------------------------------------------------- 
void ComputeNonLocalGraph(short int*** HypImg,int dpthBeg,int dpthEnd,\
int lgth,int wdth,short int*** NonLocGrph,int SzW,int NbCnx)
{
 short int i,j,k,l,m;
 short int posc,posr;
 short int NbBand;
 short int SzWdiv2;
 short int Eechdiv;
 short int nb;
 int   cpt;
 float echdiv;
 float dist;
 //int nbpix;
 
 //Connexion Graph
 NbBand=dpthEnd-dpthBeg;
 echdiv=CARRE(SzW)/(float)(NbCnx-4);
 echdiv=(int)(echdiv+0.4999);
 Eechdiv=(int)echdiv;
 SzWdiv2=(SzW/2);

 //Allocation memoire
 int* VctTmp=imatrix_allocate_1d(NbBand);

 //Presentation  
 printf("\n  > Compute NonLocalGraph (NormeL2) ");
 printf("\n  >> AVIRIS Img:[dpth:%d-%d][lgth:%d-wdth:%d]",dpthBeg,dpthEnd,lgth,wdth);
 printf("\n  >> Window Sz :[%d]",SzW);
 printf("\n  >> Connect.  :[%d](incluant 4ppv) <Ecart:%d>",NbCnx,(int)echdiv);
 fflush(stdout);

 //Init_NonLocGrph 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<NbCnx;k++)
   { NonLocGrph[0][k][(i*wdth)+j]=i;
     NonLocGrph[1][k][(i*wdth)+j]=j;
     NonLocGrph[2][k][(i*wdth)+j]=0; }
 
  //-----------------------------------------------
  //--NonLocal Graph ------------------------------
  //-----------------------------------------------
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      //>VctSpectrale[i][j]
      for(m=dpthBeg;m<dpthEnd;m++) VctTmp[m]=HypImg[m][i][j];

      //>SearchInBigWindow[posr,posc]
      //=============================
      cpt=0; nb=0;
      for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
          cpt++;
          if (cpt%Eechdiv) continue;

          posr=i-(SzWdiv2)+k;
          posc=j-(SzWdiv2)+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;
 
          //>LxDistance 
          for(dist=0.0,m=dpthBeg;m<dpthEnd;m++) 
            dist+=CARRE(VctTmp[m]-HypImg[m][posr][posc]);  

          dist=sqrt(dist);
                        
          //>RecordInGraph
          if (nb>=(NbCnx-4)) break;
          NonLocGrph[0][nb][(i*wdth)+j]=posr;
          NonLocGrph[1][nb][(i*wdth)+j]=posc;
	  NonLocGrph[2][nb][(i*wdth)+j]=(int)dist;
          nb++;       
	}

      //>4ppv
      //============================
      nb=4;
      for(k=-1;k<=1;k++) for(l=-1;l<=1;l++) 
      if (((abs(k)+abs(l))<2)&&((abs(k)+abs(l))>0))
        {
          posr=i+k;
          posc=j+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;

           //>LxDistance 
          for(dist=0.0,m=dpthBeg;m<dpthEnd;m++) 
            dist+=CARRE(VctTmp[m]-HypImg[m][posr][posc]);  

          dist=sqrt(dist);

          //>RecordInGraph
          NonLocGrph[0][nb][(i*wdth)+j]=posr;
          NonLocGrph[1][nb][(i*wdth)+j]=posc;
	  NonLocGrph[2][nb][(i*wdth)+j]=(int)dist;
          nb++;               
        }
     }//------------------------------------------ 
}

//--------------------------------
//--------------------------------
//---GESTION COULEUR--------------
//--------------------------------
//----------------------------------------------------------
// MakeColorIm
//----------------------------------------------------------   
void MakeColorImg(int*** ImgCoul,float** ImgR,float** ImgG,float** ImgB,int lgth,int wdth)
{
 int i,j;

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { ImgCoul[0][i][j]=(int)ImgR[i][j]; 
     ImgCoul[1][i][j]=(int)ImgG[i][j];
     ImgCoul[2][i][j]=(int)ImgB[i][j]; }
}

//--------------------------------
//---LAB>RGB----------------------
//--------------------------------
//----------------------------------------------------------*/
// LABToRGB                    
//----------------------------------------------------------*/
void LABToRGB(float l,float a,float b,float* r,float* g,float* bl)
{
 float x,y,z;

 LABToXYZ(l,a,b,&x,&y,&z);
 XYZToRGB(x,y,z,r,g,bl);
}

//----------------------------------------------------------
// LABToXYZ 
//----------------------------------------------------------
void LABToXYZ(float l,float a,float b,float* x,float* y,float* z)
{
 (*y)=(l+16.0)/116.0;
 (*x)=a/500.0+(*y);
 (*z)=(*y)-b/200.0;

 if (powf((*y),3)>0.008856)  (*y)=powf((*y),3);
 else                        (*y)=((*y)-16.0/116.0)/7.787;
 if (powf((*x),3)>0.008856)  (*x)=powf((*x),3);
 else                        (*x)=((*x)-16.0/116.0)/7.787;
 if (pow((*z),3)>0.008856)   (*z)=powf((*z),3); 
 else                        (*z)=((*z)-16.0/116.0)/7.787;

  (*x)=95.047*(*x);     
  (*y)=100.000*(*y);     
  (*z)=108.883*(*z);     
}

//----------------------------------------------------------
// XYZToRGB 
//----------------------------------------------------------
void XYZToRGB(float x,float y,float z,float* r,float* g,float* b)
{
 x=x/100.0;   //X from 0 to  95.047
 y=y/100.0;   //Y from 0 to 100.000
 z=z/100.0;   //Z from 0 to 108.883
  
 (*r)=x*3.2406+y*(-1.5372)+z*(-0.4986);
 (*g)=x*(-0.9689)+y*(1.8758)+z*0.0415;
 (*b)=x*0.0557+y*(-0.2040)+z*1.0570;

 if ((*r)>0.0031308) (*r)=1.055*(powf((*r),(1.0/2.4)))-0.055;
 else                (*r)=12.92*(*r);
 if ((*g)>0.0031308) (*g)=1.055*(powf((*g),(1.0/2.4)))-0.055;
 else                (*g)=12.92*(*g);
 if ((*b)>0.0031308) (*b)=1.055*(powf((*b),(1.0/2.4)))-0.055;
 else                (*b)=12.92*(*b);

 (*r)=(*r)*255.0;
 (*g)=(*g)*255.0;
 (*b)=(*b)*255.0;
}

//--------------------------------
//---RGB>LAB----------------------
//--------------------------------
//----------------------------------------------------------*/
// RGBToLAB                     
//----------------------------------------------------------*/
void RGBToLAB(float r,float g,float bl,float* l,float* a,float* b)
{
 float x,y,z;

 RGBToXYZ(r,g,bl,&x,&y,&z);
 XYZToLAB(x,y,z,l,a,b);
}

//----------------------------------------------------------*/
// RGBToXYZ                    
//----------------------------------------------------------*/
void RGBToXYZ(float r,float g,float b,float* x,float* y,float* z)
{
  r=(r/255.0);         //R from 0 to 255
  g=(g/255.0);         //G from 0 to 255
  b=(b/255.0);         //B from 0 to 255

  if (r>0.04045) r=powf(((r+0.055)/1.055),2.4);
  else           r=r/12.92;
  if (g>0.04045) g=powf(((g+0.055)/1.055),2.4);
  else           g=g/12.92;
  if (b>0.04045) b=powf(((b+0.055)/1.055),2.4);
  else           b=b/12.92;

  r=r*100;
  g=g*100;
  b=b*100;

  (*x)=r*0.4124 + g*0.3576 + b*0.1805;
  (*y)=r*0.2126 + g*0.7152 + b*0.0722;
  (*z)=r*0.0193 + g*0.1192 + b*0.9505;
}

//----------------------------------------------------------*/
// XYZToLAB                     
//----------------------------------------------------------*/
void XYZToLAB(float x,float y,float z,float* l,float* a,float* b)
{
  x=x/95.047;           
  y=y/100.000;          
  z=z/108.883;       

  if (x>0.008856) x=powf(x,1.0/3.0);
  else            x=(7.787*x)+(16.0/116.0);
  if (y>0.008856) y=powf(y,1.0/3.0);
  else            y=(7.787*y)+(16.0/116.0);
  if (z>0.008856) z=powf(z,1.0/3.0); 
  else            z=(7.787*z)+(16.0/116.0);

  (*l)=(116.0*y)-16.0;
  (*a)=500.0*(x-y);
  (*b)=200.0*(y-z);
}

//----------------------------------------------------------
// Convert_LAB_TO_RGB                 
//----------------------------------------------------------
void Convert_LAB_TO_RGB(float*** mat,int lgth,int wdth,float*** matout)
{
 int i,j,l;
 int cptU,cptD,cptUD;
 float red,green,blue; 
 float l_,a_,b_;
 float pourcU,pourcD,pourcUD;

 //Presentation
 printf("\n\n >>> ConvertPourc_LAB_TO_RGB");

  //AllocationMemoire
 float*** mattmp=fmatrix_allocate_3d(TROIS,lgth,wdth);
 float*** mattmp2=fmatrix_allocate_3d(TROIS,lgth,wdth);

 //Stat LAB 
  Stat(mat[0],lgth,wdth);
  Stat(mat[1],lgth,wdth);
  Stat(mat[2],lgth,wdth);
  printf("\n ");

 //Tampon
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[l][i][j]=mat[l][i][j];
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp2[l][i][j]=mattmp[l][i][j];
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[l][i][j]=0;
 
 //LAB>RGB
 cptD=0;
 cptU=0;
 cptUD=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { LABToRGB(mattmp[0][i][j],mattmp[1][i][j],mattmp[2][i][j],&red,&green,&blue);
      if ((red>255)||(green>255)||(blue>255))  cptU++; 
      if ((red<0)||(green<0)||(blue<0))        cptD++;
      if ((red>255)||(green>255)||(blue>255)||((red<0)||(green<0)||(blue<0))) cptUD++;
     
      if (red>255)   red=255;
      if (green>255) green=255;
      if (blue>255)  blue=255;
      if (red<0)     red=0;
      if (green<0)   green=0;
      if (blue<0)    blue=0;

      matout[0][i][j]=(int)red;
      matout[1][i][j]=(int)green;
      matout[2][i][j]=(int)blue;  }
 
  pourcU=(float)100.0*cptU/(lgth*wdth);
  pourcD=(float)100.0*cptD/(lgth*wdth);
  pourcUD=(float)100.0*cptUD/(lgth*wdth);
  printf(" \n [pcU=%.1f][pcD=%.1f][pcUD=%.1f]",pourcU,pourcD,pourcUD);
 
 //ReVerif::Calcul Pourcentage pixels staures
  cptUD=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToLAB(matout[0][i][j],matout[1][i][j],matout[2][i][j],&l_,&a_,&b_);
      if ((fabs(l_-mattmp2[0][i][j])>0.5)||(fabs(a_-mattmp2[1][i][j])>0.5)||(fabs(b_-mattmp2[2][i][j])>0.5))
      cptUD++; }
  pourcUD=(float)100.0*cptUD/(lgth*wdth);
  printf("::[pcUD=%.2f]",pourcUD);
   
 //Liberation Memoire
 if (mattmp)   free_fmatrix_3d(mattmp,TROIS);
 if (mattmp2)  free_fmatrix_3d(mattmp2,TROIS);
}

//----------------------------------------------------------
// ComputeSatPix                
//----------------------------------------------------------
void ComputeSatPix(float*** mat,int lgth,int wdth)
{
 int i,j,l;
 int cptU,cptD,cptUD;
 float red,green,blue; 
 float l_,a_,b_;
 float pourcU,pourcD,pourcUD;

  //AllocationMemoire
 float*** mattmp=fmatrix_allocate_3d(TROIS,lgth,wdth);
 float*** mattmp2=fmatrix_allocate_3d(TROIS,lgth,wdth);
 float*** matout=fmatrix_allocate_3d(TROIS,lgth,wdth);

 //Stat LAB 
  Stat(mat[0],lgth,wdth);
  Stat(mat[1],lgth,wdth);
  Stat(mat[2],lgth,wdth);
  printf("\n ");

 //Tampon
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[l][i][j]=mat[l][i][j];
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp2[l][i][j]=mattmp[l][i][j];
 for(l=0;l<TROIS;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[l][i][j]=0;
 
 //LAB>RGB
 cptD=0;
 cptU=0;
 cptUD=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { LABToRGB(mattmp[0][i][j],mattmp[1][i][j],mattmp[2][i][j],&red,&green,&blue);
      if ((red>255)||(green>255)||(blue>255))  cptU++; 
      if ((red<0)||(green<0)||(blue<0))        cptD++;
      if ((red>255)||(green>255)||(blue>255)||((red<0)||(green<0)||(blue<0))) cptUD++; 

      if (red>255)   red=255;
      if (green>255) green=255;
      if (blue>255)  blue=255;
      if (red<0)     red=0;
      if (green<0)   green=0;
      if (blue<0)    blue=0;

      matout[0][i][j]=(int)red;
      matout[1][i][j]=(int)green;
      matout[2][i][j]=(int)blue;  }
 
  pourcU=(float)100.0*cptU/(lgth*wdth);
  pourcD=(float)100.0*cptD/(lgth*wdth);
  pourcUD=(float)100.0*cptUD/(lgth*wdth);
  printf(" \n PixelSat::[pcU=%.1f][pcD=%.1f][pcUD=%.1f]",pourcU,pourcD,pourcUD);
 
 //ReVerif::Calcul Pourcentage pixels staures
  cptUD=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToLAB(matout[0][i][j],matout[1][i][j],matout[2][i][j],&l_,&a_,&b_);
      if ((fabs(l_-mattmp2[0][i][j])>0.5)||(fabs(a_-mattmp2[1][i][j])>0.5)||(fabs(b_-mattmp2[2][i][j])>0.5))
      cptUD++; }
  pourcUD=(float)100.0*cptUD/(lgth*wdth);
  printf("::[pcUD=%.2f]",pourcUD);
   
 //Liberation Memoire
 if (mattmp)   free_fmatrix_3d(mattmp,TROIS);
 if (mattmp2)  free_fmatrix_3d(mattmp2,TROIS);
 if (matout)   free_fmatrix_3d(matout,TROIS);
}

//--------------------------------
//--------------------------------
//---VALIDATION-------------------
//--------------------------------
//----------------------------------------------------------
// SAM_Validation <RGB->LAB Space><FLOATANT>
//----------------------------------------------------------
float SAM_Valid(float*** ImgRes,short int*** ImgCub,int dpth,int lgth,int wdth,float* FeatSep)
{
 int i,j,k,l,m;
 int Num;
 float dist;
 int NbPairs;
 float r1,g1,b1,r2,g2,b2;
 float l_1,a_1,b_1,l_2,a_2,b_2;
 double MoyX,MoyY;
 double StdX,StdY;
 double corr;
 double tmp;
 int nb; 

 //>Info
 printf("\n Image[depth=%d::lgth=%d::wdth=%d]",dpth,lgth,wdth);
 fflush(stdout);

 //>Comptage
 NbPairs=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 for(k=1;k<lgth;k*=2) for(l=1;l<wdth;l*=2)
 if (((i+k)<lgth)&&((j+l)<wdth)) NbPairs++;

 printf("\n  >> NbPairs=[%d]",NbPairs);
 fflush(stdout);

 //>AllocationMemoire
 float* X=fmatrix_allocate_1d(NbPairs);
 float* Y=fmatrix_allocate_1d(NbPairs);

 //---------------------------------------
 //RemplissageX::Euclidean Chroma Distance
 //---------------------------------------
 printf("\n  >> Precompute Spectral Euclidean Distance");
 fflush(stdout);
 nb=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 for(k=1;k<lgth;k*=2) for(l=1;l<wdth;l*=2)  
 if (((i+k)<lgth)&&((j+l)<wdth))
   { for(Num=0,m=0;m<dpth;m++) Num+=CARRE(ImgCub[m][i][j]-ImgCub[m][i+k][j+l]);

     dist=sqrt((float)Num);
     X[nb]=dist;
     nb++; }

  //---------------------------------------
  //RemplissageY::Euclidean (L,a,b) Distance
  //---------------------------------------
  printf("\n  >> Precompute Chroma Distance (L,a,b) plane <Floattant>");
  fflush(stdout);
  nb=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  for(k=1;k<lgth;k*=2) for(l=1;l<wdth;l*=2) 
  if (((i+k)<lgth)&&((j+l)<wdth))
    {
      dist=0.0;
      r1=ImgRes[0][i][j];
      g1=ImgRes[1][i][j];
      b1=ImgRes[2][i][j]; 
      RGBToLAB(r1,g1,b1,&l_1,&a_1,&b_1);      
      r2=ImgRes[0][i+k][j+l];
      g2=ImgRes[1][i+k][j+l];
      b2=ImgRes[2][i+k][j+l];  
      RGBToLAB(r2,g2,b2,&l_2,&a_2,&b_2);  
      dist=CARRE(l_1-l_2)+CARRE(a_1-a_2)+CARRE(b_1-b_2);
      Y[nb]=sqrt(dist);
      nb++; }

  //Statistiques
  //------------
   printf("\n  >> Precompute Moy/Std statistics");
   fflush(stdout);
   MoyX=0.0;  
   for(k=0;k<NbPairs;k++) MoyX+=X[k];
   MoyX/=(double)NbPairs;

   MoyY=0.0;  
   for(k=0;k<NbPairs;k++) MoyY+=Y[k];
   MoyY/=(double)NbPairs;

   StdX=0.0;
   for(k=0;k<NbPairs;k++) StdX+=CARRE(X[k]-MoyX);
   StdX=sqrt(StdX/(double)NbPairs);

   StdY=0.0;
   for(k=0;k<NbPairs;k++) StdY+=CARRE(Y[k]-MoyY);
   StdY=sqrt(StdY/(double)NbPairs);

  //Affiche Info
  printf("\n [moyX=%.3f  StdX=%.3f] [moyY=%.2f  StdY=%.2f]",MoyX,StdX,MoyY,StdY);
  fflush(stdout);

  //Calcul Correlation
  printf("\n  >> Compute correlation");
  fflush(stdout);
  tmp=0.0; 
  for(k=0;k<NbPairs;k++) tmp+=X[k]*Y[k];
  tmp/=((double)NbPairs);
  tmp-=(MoyX*MoyY);
  corr=tmp/(StdX*StdY);

  //Features Separability
  tmp=0.0; 
  for(k=0;k<NbPairs;k++) tmp+=fabs(Y[k]);
  tmp/=((double)NbPairs);
  printf("\n [FeatureSeparability=%.4f]",tmp);
  fflush(stdout);
  (*FeatSep)=tmp;
   
 //LiberationMemoire
  if (X)       free_fmatrix_1d(X);
  if (Y)       free_fmatrix_1d(Y);

 //Retour
  return corr;
}

