//---------------------------------------------------
// module  : bcocdm.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef BCOCDM_H
#define BCOCDM_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionHyper.h"
#include "Chrono.h"
#include "FastMapDistEucl.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200
#define TROIS 3

//>AVIRIS IMAGE
#define DEPTH   224 
#define LENGTH  512 
#define WIDTH   614 

//>DEFAULT PAR
#define RSBMIN  10
#define SZW      60
#define NBCNX    4+4 
#define REGUL    0.1  

//>METROPOLIS
#define NBIT_METR        50    
#define TEMPMET_INIT     1.0   
#define TEMPMET_FINAL    0.001
#define RADIUS_MET       3
#define PREC_MET         1

//>PRE-COMPUTATION
#define FACT_CUBE 2
#define LMIN    0
#define LMAX  150
#define AMIN  -75
#define AMAX   75
#define BMIN  -75
#define BMAX   75 


//------------------------------------------------
// CLASSE DISPLAYHYPER -----------------------------
//------------------------------------------------
class DisplayHyper
{
  //--Donnees--
  //-----------
  public:

  //>Matrices Img
  short int***  ImgCube;
  int***    ImgCoul;

  //>Metrop. & Pre-computed
  float**** MatxGrd;
  short int****  CubLabRgbLab;

  //>Parametres <IMG>
  int width,length,depth;


  //>Parametre <ALGO>
  float Regul;      

  //>Flag
  int  flag_save;
  int  flag_visu;
  int  flag_corr;

  //>Utile
  char Name_Img[NCHAR];
  char Extension[NCHAR];  
  char InfoProcess[10*NCHAR];
  float** BandInfo;

  //>Mesures Finales
  float Correlation; 
  float FeatSep;
  float NrjImg;
  int   TimeSec;
  
  public:
  DisplayHyper();
  ~DisplayHyper();
       
  //>Methodes
  void Display();
  
 //=========================================
 // File>f_DisplayHyper2.cc 
 //=========================================
  void FillInfoProcess();
  float Randomize(void);
  float DiffMat(float**,float**,int,int,float);
  float ComputeNrj(float***,int,int,short int***,int,float,float);
  float ComputeLocNrj(float***,int,int,float*,int,short int***,int,float,float);
  void  Metropolis(float***,float***,int,int,short int***,int,float,float);

  void  FillCubeLabRgbLab();
  float ComputeNrjPairwise(float***,float***,int,int,int);
  float ComputeScalingFactor(float***,short int***,int,int,int,float,int);
  void  GoodRangeLABvalues(float***,int,int,float);
  void  ValLabRgbLab(float*,float*,float*);
  float ComputeNrjGraph(float***,int,int,short int***,int,float,float);
};

#endif 
